                                                                     
                                                                     
                                                                     
                                             
//-----------------------------------------------------------------------------------------// 
// +-------------------------------------------------------------------------------------+ //
// |                                     PX4_FX.mq4                                      | //
// |                               N Roets Copyright 2006                                | //
// |                               Works on M15 timeframe                                | //
// |                      Place on USDCHFm, USDJPYm, EURUSDm & GBPUSDm                   | //
// +-------------------------------------------------------------------------------------+ //
//-----------------------------------------------------------------------------------------// 

#property copyright "Nico Roets Copyright  2006"

extern double lots=1.0;
extern int MaxTrades=1;
extern bool ManageMoney = false;
extern int Risk = 2;
extern bool ProfitTrailing = true;  
extern bool UseSound = true;  

extern int StopLoss = 40;
extern int StopLoss1 = 20;

extern int TakeProfit = 100;
extern int TakeProfit1 = 60; 

extern int TrailingStop = 20;
  
int TrailingStep = 1;   
string NameFileSound  = "expert.wav";  


int IDT;
void deinit() {
   Comment("");
}

//--------------------------------------------------------------------------------------// 

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && IDT==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start(){

 for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      TrailingPositions();
    }
  }

   if(orderscnt()<MaxTrades){
      if(ManageMoney==true) lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
      //if(CurTime()-OrderOpenTime()<61) return(0);
      
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){
 
  bool Buy, Sell, Buy1 , Sell1;

double   MA1 =iMA(NULL,0,13,0,MODE_EMA,PRICE_HIGH,1);

double   MA1A =iMA(NULL,0,13,0,MODE_EMA,PRICE_HIGH,2);


double   MA2 =iMA(NULL,0,13,0,MODE_EMA,PRICE_LOW,1);

double  MA2A =iMA(NULL,0,13,0,MODE_EMA,PRICE_LOW,2);
   

double   MA3=iMA(NULL,0,5,0,MODE_LWMA,PRICE_CLOSE,1);

double  MA3A=iMA(NULL,0,5,0,MODE_LWMA,PRICE_CLOSE,2);




Buy = False;
if ( MA3A < MA2A && MA3 > MA2 )
Buy = True;

Buy1 = False;
if ( MA3A < MA1A && MA3 > MA1 )
Buy1 = True;

Sell = False;
if ( MA3A > MA1A && MA3 < MA1 )
Sell = True;

Sell1 = False;
if ( MA3A > MA2A  && MA3 < MA2 )
Sell1 = True;

  
   double TP,SL,TP1,SL1;
//--------------------------------------------------------------------------------------// 
   if (Buy){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(StopLoss1==0){SL1=0;}else{SL1=Ask-StopLoss1*Point;}

      
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      if(TakeProfit1==0){TP1=0;}else{TP1=Ask+TakeProfit1*Point;}

      
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"PX4",IDT,0,LawnGreen); 
      OrderSend(Symbol(),OP_SELLSTOP,lots,Ask,1,SL1,TP1,"PX4",IDT,0,HotPink); 

   }
   
   if (Buy1){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(StopLoss1==0){SL1=0;}else{SL1=Ask-StopLoss1*Point;}

      
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      if(TakeProfit1==0){TP1=0;}else{TP1=Ask+TakeProfit1*Point;}

      
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"PX4",IDT,0,LawnGreen); 
      OrderSend(Symbol(),OP_SELLSTOP,lots,Ask,1,SL1,TP1,"PX4",IDT,0,HotPink); 

   }
   
   
   
   if (Sell){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(StopLoss1==0){SL1=0;}else{SL1=Bid+StopLoss1*Point;}

      
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      if(TakeProfit1==0){TP1=0;}else{TP1=Bid-TakeProfit1*Point;}

      
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"PX4",IDT,0,HotPink);
      OrderSend(Symbol(),OP_BUYSTOP,lots,Bid,1,SL1,TP1,"PX4",IDT,0,LawnGreen); 

       
   }
   
   if (Sell1){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(StopLoss1==0){SL1=0;}else{SL1=Bid+StopLoss1*Point;}

      
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      if(TakeProfit1==0){TP1=0;}else{TP1=Bid-TakeProfit1*Point;}

      
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"PX4",IDT,0,HotPink);
      OrderSend(Symbol(),OP_BUYSTOP,lots,Bid,1,SL1,TP1,"PX4",IDT,0,LawnGreen); 

       
   }
   
   
   
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/10;  
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 



